#include <TApplication.h>
#include <TGClient.h>
#include <TGButton.h>
#include <TGNumberEntry.h>
#include <TGTextEntry.h>
#include <TGFrame.h>
#include <TGFileDialog.h>
#include <TGLabel.h>
#include <TFrame.h>
#include <TRootEmbeddedCanvas.h>
#include <TGStatusBar.h>
#include <TCanvas.h>
#include <TF1.h>
#include <TRandom.h>
#include <TGraph.h>
#include <TProfile.h>
#include <TH1.h>
#include "Riostream.h"

Double_t gaus_gauscte(Double_t *x, Double_t *par)
{
  if(par[2]==0) return 1e30;
  if(x[0]>(par[3]-.4) && x[0]<(par[3]+.4)) {
    TF1::RejectPoint();
  }
   Double_t arg = (x[0]-par[1])/par[2];
   Double_t res = par[0]*TMath::Exp(-0.5*arg*arg);
  if(x[0]>par[5]-0.4 && x[0]<par[5]+0.4) {
    res=par[4];
  }
  return res;
}
Double_t gaus_gauscte2(Double_t *x, Double_t *par)
{
  if(par[2]==0) return 1e30;
  if(x[0]>(par[3]-.4) && x[0]<(par[3]+.4)) {
    TF1::RejectPoint();
  }
   Double_t arg = (x[0]-par[1])/par[2];
   Double_t res = par[0]*TMath::Exp(-0.5*arg*arg);
  if(x[0]>par[5]-0.4 && x[0]<par[6]+0.4) {
    res=par[4];
  }
  return res;
}
Double_t gaus_badchan(Double_t *x, Double_t *par)
{
  if(par[2]==0) return 1e30;
  if(x[0]>(par[3]-.4) && x[0]<(par[3]+.4)) {
    TF1::RejectPoint();
    return 0;
  }
   Double_t arg = (x[0]-par[1])/par[2];
   Double_t res = par[0]*TMath::Exp(-0.5*arg*arg);
   return res;
}
Double_t gaus_badchan2(Double_t *x, Double_t *par)
{
  if(par[2]==0) return 1e30;
  if(x[0]>(par[3]-.4) && x[0]<(par[3]+.4)) {
    TF1::RejectPoint();
    return 0;
  }
  if(x[0]>(par[4]-.4) && x[0]<(par[4]+.4)) {
    TF1::RejectPoint();
    return 0;
  }
   Double_t arg = (x[0]-par[1])/par[2];
   Double_t res = par[0]*TMath::Exp(-0.5*arg*arg);
   return res;
}
Double_t gaus_goodchan(Double_t *x, Double_t *par)
{
  if(par[2]==0) return 1e30;
  Double_t arg = (x[0]-par[1])/par[2];
  Double_t res = par[0]*TMath::Exp(-0.5*arg*arg);
  return res;
}

void analyssum(void)
{

  ifstream in,in2,in3;

  Int_t nchan,chan,adc,num,gas,t,h,nevent,badevnt,der,mesh,cder,more700,N,NN;
  Float_t adcsub,adcsubbc,pos,adcsum,adcsum2,adcsum3,driftsum,meshsum,sumchan,allsum;
  Double_t pedmean[96],pedrms[96];
  TProfile *hpos2;  
  Double_t postab[96];
  Double_t badevent[5000];

  Int_t dat0_0[6]={71,71,69,74,0,0},dat0_1[6]={71,77,74,80,0,0},dat0_15[6]={71,82,78,86,0,0};
  Int_t dat2_0[6]={64,64,62,67,0,0},dat2_1[6]={64,70,67,74,0,0},dat2_15[6]={64,75,72,80,0,0};
  Int_t dat4_0[6]={58,58,56,60,0,0},dat4_1[6]={58,64,61,67,0,0},dat4_15[6]={58,69,64,74,0,0};
  Int_t dat6_0[6]={51,51,48,54,0,0},dat6_1[6]={51,57,54,60,55,0},dat6_15[6]={51,63,58,68,0,0};
  Int_t dat8_0[6]={44,44,42,47,0,0},dat8_1[6]={44,51,48,54,0,0},dat8_15[6]={44,56,52,60,55,0};
  Int_t dat10_0[6]={36,36,34,39,0,0},dat10_1[6]={36,43,40,46,0,0},dat10_15[6]={36,49,44,53,47,0};
  Int_t dat13_0[6]={27,28,25,30,0,0},dat13_1[6]={27,34,32,37,0,0},dat13_15[6]={27,41,36,46,39,0};
  Int_t dat16_0[6]={17,18,15,20,0,0},dat16_1[6]={17,24,22,27,0,0},dat16_15[6]={17,30,26,36,31,0};
  Int_t dat18_0[6]={11,11,8,14,0,0},dat18_1[6]={11,17,15,20,0,0},dat18_15[6]={11,24,20,30,21,0};
  Int_t dat20_0[6]={4,4,2,7,0,0},dat20_1[6]={4,11,9,13,0,0},dat20_15[6]={4,17,14,21,0,0};

  Int_t dat20_15_630={4,17,14,20,0,0};
  Int_t dat20_15_700={4,12,9,16,0,0};
  Int_t dat20_15_750={4,10,8,13,0,0};
  Int_t dat20_15_800={4,9,6,12,0,0};
  Int_t dat20_15_850={4,8,6,11,0,0};
  Int_t dat20_15_900={4,7,6,10,0,0};
  Int_t dat20_15_950={4,7,3,10,0,0};
  Int_t dat20_15_1000={4,7,3,9,0,0};
  Int_t dat20_15_1050={4,6,3,9,0,0};
  Int_t dat20_15_1080={4,6,3,9,0,0};

  Int_t dat92_15_630={,,,,,};
  Int_t dat92_15_700={,,,,,};
  Int_t dat92_15_750={,,,,,};
  Int_t dat92_15_800={,,,,,};
  Int_t dat92_15_850={,,,,,};
  Int_t dat92_15_900={,,,,,};
  Int_t dat92_15_950={,,,,,};
  Int_t dat92_15_1000={,,,,,};
  Int_t dat92_15_1050={,,,,,};
  Int_t dat92_15_1080={,,,,,};


  Int_t bm,bp,bc,cmesh,bc2,cmesh2;


  Int_t dat[6];
  for(Int_t i=0;i<6;i++){
    dat[i]=dat2_0[i];
  }

  TString toto="../newgui/05.03/B0_Vm400_Vd550_vis2_5%.dat";

  //TString vis,B;
  //vis="2";
  //B="1.5"; 
  //toto+=B;
  //toto+="_Vis";
  //toto+=vis;
  //toto+=".dat";

  in.open(toto);  
  in2.open("../newgui/12.02.ped");
  in3.open(toto); 

  cmesh=dat[0];
  cder=dat[1];

  bm=dat[2];
  bp=dat[3];

  bc=dat[4];

  hpos2 = new TProfile("pos","Position",96,-0.5,95.5,0,1);

  for(Int_t i=0;i<96; i++) {
    in2 >> pedmean[i] >> pedrms[i];
    t=(i+1)/16.1;
    h=pow(-1,t);
    gas=h*(2*(i+1)+(h-2)*(16*t+0.5*(7-5*h)));
    gas=gas-1;    
    gas=gas-2*(gas%4)+3;
    TString hname="hadc";
    hname+=i;
    TString htitle="ADC Spectrum - Channel #";
    htitle+=i;
    }

  //Première boucle pour repérer les mauvais événements
  N=0;
  in3 >> nevent;
  //N++;
  for(Int_t i=0;i<nevent; i++){
    badevent[i]=0;
  }
  for(Int_t i=0;i<nevent; i++){
    in3 >> nchan;
    //N++;
    //if(nchan!=96)cout<<"CLAQUAGE!!!!!  "<<nchan<<"   "<<i<<"   "<<N<<endl;
    mesh=0;
    der=0;
    for(Int_t j=0;j<nchan;j++) {
      in3 >> chan >> adc; 
      //N++;
      adcsub=adc-pedmean[chan];
      if(adcsub<13)adcsub=0; 
      t=(chan+1)/16.1;
      h=pow(-1,t);
      gas=h*(2*(chan+1)+(h-2)*(16*t+0.5*(7-5*h)));
      gas=gas-1;    
      gas=gas-2*(gas%4)+3;
      if(gas==cmesh&&adcsub>10)mesh=1;
      if(gas==cder&&adcsub>10)der=1;
    }
    if(mesh==1&&der==1)N++;
    if(mesh==0||der==0)badevent[i]=1;
    //if(mesh==0||der==0)cout<<"Bad event: "<<i<<endl;
  }
  cout<<"N: "<<N<<endl;
  for(Int_t k=0;k<96;k++) {
    postab[k]=0.;
  }
  //Deuxième boucle pour calculer la position moyenne avec les événements bons
  driftsum=0.;
  meshsum=0.;
  allsum=0.;
  in >> nevent;
  NN=0;
  for(Int_t i=0;i<nevent; i++){
    in >> nchan;
    pos=0;
    adcsum=0;
    t=0;
    more700=0;
    adcsum=0;
    adcsum2=0;
    adcsum3=0;
/*     for(Int_t k=0;k<96;k++) { */
/*       postab[k]=0.; */
/*     } */
    
    for(Int_t j=0;j<nchan;j++) {
      in >> chan >> adc;
      adcsub=adc-pedmean[chan];
      if(adcsub>800) more700=1;
      if(adcsub<13)adcsub=0; 
      t=(chan+1)/16.1;
      h=pow(-1,t);
      gas=h*(2*(chan+1)+(h-2)*(16*t+0.5*(7-5*h)));
      gas=gas-1;    
      gas=gas-2*(gas%4)+3;
      pos+=adcsub*gas;

      if(!more700 && !badevent[i]) {
	postab[gas]+=adcsub;
	adcsum+=adcsub;
      }
      if(!more700 && !badevent[i] && gas>=bm && gas<=bp) {
 	adcsum3+=adcsub;
      }
      if(!more700 && !badevent[i] && gas>(cmesh-0.4) && gas<(cmesh+0.4)) {
      //if(!more700 && !badevent[i] && gas>(cmesh-0.4) && gas<(cmesh2+0.4)) {
 	adcsum2+=adcsub;
       }

    }

    driftsum+=adcsum3;
    meshsum+=adcsum2;
    //if(!badevent[i])cout<<"driftsum: "<<adcsum<<"  "<<i<<endl;

    if(adcsum>0 && bc!=0) {
      adcsubbc=dat[5]*adcsum;
      pos+=adcsubbc*bc;
      adcsum+=adcsubbc;
    }
    if(adcsum>0 && !more700 && !badevent[i]) {
      NN++;
      allsum+=adcsum;
      pos/=adcsum;
      for(Int_t k=0;k<96;k++) {
	postab[k]/=adcsum;
	//if(k==17)postab[k]-=0.23;
	//if(k==18)postab[k]-=0.085;
	hpos2->Fill(k,postab[k],1);
      }
    }
  }
  allsum/=NN;
  cout<<"NN: "<<NN<<endl;
  cout<<"allsum: "<<allsum<<endl;
  gROOT->SetStyle("Plain");
  gStyle->SetOptTitle(0);
  gStyle->SetOptStat(0);
  gStyle->SetOptFit(1);
  hpos2->Draw();
  //TF1 *badgaus = new TF1("badgaus",gaus_badchan,bm,bp,4);
  TF1 *badgaus = new TF1("badgaus",gaus_gauscte,bm,bp,6);
  TF1 *goodgaus = new TF1("goodgaus",gaus_goodchan,bm,bp,3);
  //badgaus->SetParameters(0.5,cder,1,bc);
  badgaus->SetParameters(0.5,cder,1,bc,0.1,cmesh);
  badgaus->FixParameter(3,bc);
  badgaus->FixParameter(5,cmesh);
  //badgaus->FixParameter(6,cmesh2);
  hpos2->Fit("badgaus","0");
  badgaus->Draw("same");
  goodgaus->SetParameters(badgaus->GetParameter(0),badgaus->GetParameter(1),badgaus->GetParameter(2));
  goodgaus->SetLineColor(2);
  goodgaus->Draw("same");

  //calcul de l'ADC du mauvais channel

  Double_t arg = (bc-badgaus->GetParameter(1))/badgaus->GetParameter(2);
  Double_t resbc = badgaus->GetParameter(0)*TMath::Exp(-0.5*arg*arg);
  Double_t arg = (cmesh-1-badgaus->GetParameter(1))/badgaus->GetParameter(2);
  Double_t resbc34 = badgaus->GetParameter(0)*TMath::Exp(-0.5*arg*arg);
  Double_t arg = (cmesh-badgaus->GetParameter(1))/badgaus->GetParameter(2);
  Double_t resbc35 = badgaus->GetParameter(0)*TMath::Exp(-0.5*arg*arg);
  Double_t arg = (cmesh+1-badgaus->GetParameter(1))/badgaus->GetParameter(2);
  Double_t resbc36 = badgaus->GetParameter(0)*TMath::Exp(-0.5*arg*arg);
  sumchan=0.;
  for(Int_t i=bm;i<=bp;i++)
    {
  Double_t arg = (i-badgaus->GetParameter(1))/badgaus->GetParameter(2);
  Double_t res = badgaus->GetParameter(0)*TMath::Exp(-0.5*arg*arg);
  sumchan+=res;
    }
  cout<<"Bad channel percent: "<<resbc/sumchan<<endl;
  sumchan-=resbc;
  meshsum=meshsum/NN;
  driftsum=driftsum/NN;

  cout<<"Bad channel added: "<<driftsum*resbc<<endl;
  driftsum=driftsum+driftsum*resbc;

  //meshsum=driftsum*(badgaus->GetParameter(4)-goodgaus->Integral(cmesh-0.5,cmesh+0.5));  
  //cout<<driftsum<<"  "<<badgaus->GetParameter(4)<<"  "<<goodgaus->Integral(cmesh-0.5,cmesh+0.5)<<endl;
  //driftsum-=meshsum;

  cout<<"Driftsum: "<<driftsum<<endl;
  cout<<"Meshsum: "<<meshsum<<endl;
  //cout<<"Meshsum ratio: "<<meshsum/allsum<<endl;

  in.close();
  in2.close();
  in3.close();
}
